#ifndef FGGL_UTIL_CHRONO_H
#define FGGL_UTIL_CHRONO_H

namespace fggl::util {

	class Timer {
		public:
			inline void frequency(long freq) {
				m_freq = freq;
			}

			inline void setup(long epoch) {
				m_first = epoch;
				m_last = m_first;
				m_curr = m_first;
			}

			inline void tick(long time) {
				m_last = m_curr;
				m_curr = time;
			}

			inline float delta() const {
				return (m_curr - m_last) / m_freq;
			}

		private:
			float m_freq;
			float m_first;
			float m_last;
			float m_curr;
	};
};

#endif
